diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/misc.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/misc.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/misc.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/misc.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 192,198 ****
  }
  
  /**
!  * If siteurl or home changed, flush rewrite rules.
   *
   * @since 2.1.0
   *
--- 192,198 ----
  }
  
  /**
!  * If siteurl, home or page_on_front changed, flush rewrite rules.
   *
   * @since 2.1.0
   *
***************
*** 209,214 ****
--- 209,215 ----
  
  add_action( 'update_option_home', 'update_home_siteurl', 10, 2 );
  add_action( 'update_option_siteurl', 'update_home_siteurl', 10, 2 );
+ add_action( 'update_option_page_on_front', 'update_home_siteurl', 10, 2 );
  
  /**
   * Shorten an URL, to be used as link text
***************
*** 325,342 ****
  		$option = $_POST['wp_screen_options']['option'];
  		$value = $_POST['wp_screen_options']['value'];
  
! 		if ( !preg_match( '/^[a-z_-]+$/', $option ) )
  			return;
  
- 		$option = str_replace('-', '_', $option);
- 
  		$map_option = $option;
  		$type = str_replace('edit_', '', $map_option);
  		$type = str_replace('_per_page', '', $type);
! 		if ( in_array($type, get_post_types()) )
! 			$map_option = 'edit_per_page';
! 		if ( in_array( $type, get_taxonomies()) )
  			$map_option = 'edit_tags_per_page';
  
  		switch ( $map_option ) {
  			case 'edit_per_page':
--- 326,343 ----
  		$option = $_POST['wp_screen_options']['option'];
  		$value = $_POST['wp_screen_options']['value'];
  
! 		if ( $option != sanitize_key( $option ) )
  			return;
  
  		$map_option = $option;
  		$type = str_replace('edit_', '', $map_option);
  		$type = str_replace('_per_page', '', $type);
! 		if ( in_array( $type, get_taxonomies() ) )
  			$map_option = 'edit_tags_per_page';
+ 		elseif ( in_array( $type, get_post_types() ) )
+ 			$map_option = 'edit_per_page';
+ 		else
+ 			$option = str_replace('-', '_', $option);
  
  		switch ( $map_option ) {
  			case 'edit_per_page':
***************
*** 524,559 ****
  }
  
  /**
-  * Workaround for Windows bug in is_writable() function
-  *
-  * @since 2.8.0
-  *
-  * @param string $path
-  * @return bool
-  */
- function win_is_writable( $path ) {
- 	/* will work in despite of Windows ACLs bug
- 	 * NOTE: use a trailing slash for folders!!!
- 	 * see http://bugs.php.net/bug.php?id=27609
- 	 * see http://bugs.php.net/bug.php?id=30931
- 	 */
- 
- 	if ( $path[strlen( $path ) - 1] == '/' ) // recursively return a temporary file path
- 		return win_is_writable( $path . uniqid( mt_rand() ) . '.tmp');
- 	else if ( is_dir( $path ) )
- 		return win_is_writable( $path . '/' . uniqid( mt_rand() ) . '.tmp' );
- 	// check tmp file for read/write capabilities
- 	$should_delete_tmp_file = !file_exists( $path );
- 	$f = @fopen( $path, 'a' );
- 	if ( $f === false )
- 		return false;
- 	fclose( $f );
- 	if ( $should_delete_tmp_file )
- 		unlink( $path );
- 	return true;
- }
- 
- /**
   * Display the default admin color scheme picker (Used in user-edit.php)
   *
   * @since 3.0.0
--- 525,530 ----
***************
*** 566,581 ****
  if ( empty($current_color) )
  	$current_color = 'fresh';
  foreach ( $_wp_admin_css_colors as $color => $color_info ): ?>
! <div class="color-option"><input name="admin_color" id="admin_color_<?php echo $color; ?>" type="radio" value="<?php echo esc_attr($color) ?>" class="tog" <?php checked($color, $current_color); ?> />
  	<table class="color-palette">
  	<tr>
  	<?php foreach ( $color_info->colors as $html_color ): ?>
! 	<td style="background-color: <?php echo $html_color ?>" title="<?php echo $color ?>">&nbsp;</td>
  	<?php endforeach; ?>
  	</tr>
  	</table>
  
! 	<label for="admin_color_<?php echo $color; ?>"><?php echo $color_info->name ?></label>
  </div>
  	<?php endforeach; ?>
  </fieldset>
--- 537,552 ----
  if ( empty($current_color) )
  	$current_color = 'fresh';
  foreach ( $_wp_admin_css_colors as $color => $color_info ): ?>
! <div class="color-option"><input name="admin_color" id="admin_color_<?php echo esc_attr( $color ); ?>" type="radio" value="<?php echo esc_attr( $color ); ?>" class="tog" <?php checked($color, $current_color); ?> />
  	<table class="color-palette">
  	<tr>
  	<?php foreach ( $color_info->colors as $html_color ): ?>
! 	<td style="background-color: <?php echo esc_attr( $html_color ); ?>" title="<?php echo esc_attr( $color ); ?>">&nbsp;</td>
  	<?php endforeach; ?>
  	</tr>
  	</table>
  
! 	<label for="admin_color_<?php echo esc_attr( $color ); ?>"><?php echo esc_html( $color_info->name ); ?></label>
  </div>
  	<?php endforeach; ?>
  </fieldset>
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/ms-deprecated.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/ms-deprecated.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/ms-deprecated.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/ms-deprecated.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 73,76 ****
  function wpmu_get_blog_allowedthemes( $blog_id = 0 ) {
  	_deprecated_function( __FUNCTION__, '3.4', 'WP_Theme::get_allowed_on_site()' );
  	return array_map( 'intval', WP_Theme::get_allowed_on_site( $blog_id ) );
! }
\ No newline at end of file
--- 73,78 ----
  function wpmu_get_blog_allowedthemes( $blog_id = 0 ) {
  	_deprecated_function( __FUNCTION__, '3.4', 'WP_Theme::get_allowed_on_site()' );
  	return array_map( 'intval', WP_Theme::get_allowed_on_site( $blog_id ) );
! }
! 
! function ms_deprecated_blogs_file() {}
\ No newline at end of file
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/ms.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/ms.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/ms.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/ms.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 25,33 ****
  	if ( defined( 'WP_IMPORTING' ) )
  		return $file;
  
! 	$space_allowed = 1048576 * get_space_allowed();
! 	$space_used = get_dirsize( BLOGUPLOADDIR );
! 	$space_left = $space_allowed - $space_used;
  	$file_size = filesize( $file['tmp_name'] );
  	if ( $space_left < $file_size )
  		$file['error'] = sprintf( __( 'Not enough space to upload. %1$s KB needed.' ), number_format( ($file_size - $space_left) /1024 ) );
--- 25,32 ----
  	if ( defined( 'WP_IMPORTING' ) )
  		return $file;
  
! 	$space_left = get_upload_space_available();
! 
  	$file_size = filesize( $file['tmp_name'] );
  	if ( $space_left < $file_size )
  		$file['error'] = sprintf( __( 'Not enough space to upload. %1$s KB needed.' ), number_format( ($file_size - $space_left) /1024 ) );
***************
*** 56,69 ****
  	global $wpdb, $current_site;
  
  	$switch = false;
! 	if ( $blog_id != $wpdb->blogid ) {
  		$switch = true;
  		switch_to_blog( $blog_id );
- 		$blog = get_blog_details( $blog_id );
- 	} else {
- 		$blog = $GLOBALS['current_blog'];
  	}
  
  	do_action( 'delete_blog', $blog_id, $drop );
  
  	$users = get_users( array( 'blog_id' => $blog_id, 'fields' => 'ids' ) );
--- 55,67 ----
  	global $wpdb, $current_site;
  
  	$switch = false;
! 	if ( get_current_blog_id() != $blog_id ) {
  		$switch = true;
  		switch_to_blog( $blog_id );
  	}
  
+ 	$blog = get_blog_details( $blog_id );
+ 
  	do_action( 'delete_blog', $blog_id, $drop );
  
  	$users = get_users( array( 'blog_id' => $blog_id, 'fields' => 'ids' ) );
***************
*** 91,97 ****
  
  		$wpdb->delete( $wpdb->blogs, array( 'blog_id' => $blog_id ) );
  
! 		$dir = apply_filters( 'wpmu_delete_blog_upload_dir', WP_CONTENT_DIR . "/blogs.dir/{$blog_id}/files/", $blog_id );
  		$dir = rtrim( $dir, DIRECTORY_SEPARATOR );
  		$top_dir = $dir;
  		$stack = array($dir);
--- 88,95 ----
  
  		$wpdb->delete( $wpdb->blogs, array( 'blog_id' => $blog_id ) );
  
! 		$uploads = wp_upload_dir();
! 		$dir = apply_filters( 'wpmu_delete_blog_upload_dir', $uploads['basedir'], $blog_id );
  		$dir = rtrim( $dir, DIRECTORY_SEPARATOR );
  		$top_dir = $dir;
  		$stack = array($dir);
***************
*** 112,117 ****
--- 110,116 ----
  					else if ( @is_file( $dir . DIRECTORY_SEPARATOR . $file ) )
  						@unlink( $dir . DIRECTORY_SEPARATOR . $file );
  				}
+ 				@closedir( $dh );
  			}
  			$index++;
  		}
***************
*** 121,126 ****
--- 120,127 ----
  			if ( $dir != $top_dir)
  			@rmdir( $dir );
  		}
+ 
+ 		clean_blog_cache( $blog );
  	}
  
  	if ( $switch )
***************
*** 223,234 ****
  
  	if ( $current_user->user_email != $_POST['email'] ) {
  		if ( !is_email( $_POST['email'] ) ) {
! 			$errors->add( 'user_email', __( "<strong>ERROR</strong>: The e-mail address isn't correct." ), array( 'form-field' => 'email' ) );
  			return;
  		}
  
  		if ( $wpdb->get_var( $wpdb->prepare( "SELECT user_email FROM {$wpdb->users} WHERE user_email=%s", $_POST['email'] ) ) ) {
! 			$errors->add( 'user_email', __( "<strong>ERROR</strong>: The e-mail address is already used." ), array( 'form-field' => 'email' ) );
  			delete_option( $current_user->ID . '_new_email' );
  			return;
  		}
--- 224,235 ----
  
  	if ( $current_user->user_email != $_POST['email'] ) {
  		if ( !is_email( $_POST['email'] ) ) {
! 			$errors->add( 'user_email', __( "<strong>ERROR</strong>: The email address isn&#8217;t correct." ), array( 'form-field' => 'email' ) );
  			return;
  		}
  
  		if ( $wpdb->get_var( $wpdb->prepare( "SELECT user_email FROM {$wpdb->users} WHERE user_email=%s", $_POST['email'] ) ) ) {
! 			$errors->add( 'user_email', __( "<strong>ERROR</strong>: The email address is already used." ), array( 'form-field' => 'email' ) );
  			delete_option( $current_user->ID . '_new_email' );
  			return;
  		}
***************
*** 273,378 ****
  add_action( 'admin_notices', 'new_user_email_admin_notice' );
  
  /**
!  * Determines if there is any upload space left in the current blog's quota.
   *
!  * @since 3.0.0
!  * @return bool True if space is available, false otherwise.
!  */
! function is_upload_space_available() {
! 	if ( get_site_option( 'upload_space_check_disabled' ) )
! 		return true;
! 
! 	if ( !( $space_allowed = get_upload_space_available() ) )
! 		return false;
! 
! 	return true;
! }
! 
! /**
!  * @since 3.0.0
!  *
!  * @return int of upload size limit in bytes
!  */
! function upload_size_limit_filter( $size ) {
! 	$fileupload_maxk = 1024 * get_site_option( 'fileupload_maxk', 1500 );
! 	if ( get_site_option( 'upload_space_check_disabled' ) )
! 		return min( $size, $fileupload_maxk );
! 
! 	return min( $size, $fileupload_maxk, get_upload_space_available() );
! }
! /**
!  * Determines if there is any upload space left in the current blog's quota.
   *
!  * @return int of upload space available in bytes
   */
! function get_upload_space_available() {
! 	$space_allowed = get_space_allowed() * 1024 * 1024;
  	if ( get_site_option( 'upload_space_check_disabled' ) )
! 		return $space_allowed;
  
! 	$dir_name = trailingslashit( BLOGUPLOADDIR );
! 	if ( !( is_dir( $dir_name) && is_readable( $dir_name ) ) )
! 		return $space_allowed;
! 
!   	$dir = dir( $dir_name );
!    	$size = 0;
! 
! 	while ( $file = $dir->read() ) {
! 		if ( $file != '.' && $file != '..' ) {
! 			if ( is_dir( $dir_name . $file) ) {
! 				$size += get_dirsize( $dir_name . $file );
! 			} else {
! 				$size += filesize( $dir_name . $file );
! 			}
! 		}
  	}
- 	$dir->close();
- 
- 	if ( ( $space_allowed - $size ) <= 0 )
- 		return 0;
- 
- 	return $space_allowed - $size;
  }
  
  /**
!  * Returns the upload quota for the current blog.
   *
!  * @return int Quota
   */
- function get_space_allowed() {
- 	$space_allowed = get_option( 'blog_upload_space' );
- 
- 	if ( ! is_numeric( $space_allowed ) )
- 		$space_allowed = get_site_option( 'blog_upload_space' );
- 
- 	if ( empty( $space_allowed ) || ! is_numeric( $space_allowed ) )
- 		$space_allowed = 50;
- 
- 	return $space_allowed;
- }
- 
  function display_space_usage() {
! 	$space = get_space_allowed();
! 	$used = get_dirsize( BLOGUPLOADDIR ) / 1024 / 1024;
  
! 	$percentused = ( $used / $space ) * 100;
  
! 	if ( $space > 1000 ) {
! 		$space = number_format( $space / 1024 );
  		/* translators: Gigabytes */
  		$space .= __( 'GB' );
  	} else {
  		/* translators: Megabytes */
  		$space .= __( 'MB' );
  	}
  	?>
! 	<strong><?php printf( __( 'Used: %1s%% of %2s' ), number_format( $percentused ), $space ); ?></strong>
  	<?php
  }
  
  // Edit blog upload space setting on Edit Blog page
  function upload_space_setting( $id ) {
! 	$quota = get_blog_option( $id, 'blog_upload_space' );
  	if ( !$quota )
  		$quota = '';
  
--- 274,355 ----
  add_action( 'admin_notices', 'new_user_email_admin_notice' );
  
  /**
!  * Check whether a blog has used its allotted upload space.
   *
!  * @since MU
   *
!  * @param bool $echo Optional. If $echo is set and the quota is exceeded, a warning message is echoed. Default is true.
!  * @return int
   */
! function upload_is_user_over_quota( $echo = true ) {
  	if ( get_site_option( 'upload_space_check_disabled' ) )
! 		return false;
  
! 	$space_allowed = get_space_allowed();
! 	if ( empty( $space_allowed ) || !is_numeric( $space_allowed ) )
! 		$space_allowed = 10; // Default space allowed is 10 MB
! 
! 	$space_used = get_space_used();
! 
! 	if ( ( $space_allowed - $space_used ) < 0 ) {
! 		if ( $echo )
! 			_e( 'Sorry, you have used your space allocation. Please delete some files to upload more files.' );
! 		return true;
! 	} else {
! 		return false;
  	}
  }
  
  /**
!  * Displays the amount of disk space used by the current blog. Not used in core.
   *
!  * @since MU
   */
  function display_space_usage() {
! 	$space_allowed = get_space_allowed();
! 	$space_used = get_space_used();
  
! 	$percent_used = ( $space_used / $space_allowed ) * 100;
  
! 	if ( $space_allowed > 1000 ) {
! 		$space = number_format( $space_allowed / 1024 );
  		/* translators: Gigabytes */
  		$space .= __( 'GB' );
  	} else {
+ 		$space = number_format( $space_allowed );
  		/* translators: Megabytes */
  		$space .= __( 'MB' );
  	}
  	?>
! 	<strong><?php printf( __( 'Used: %1$s%% of %2$s' ), number_format( $percent_used ), $space ); ?></strong>
  	<?php
  }
  
+ /**
+  * Get the remaining upload space for this blog.
+  *
+  * @since MU
+  * @uses upload_is_user_over_quota()
+  * @uses get_space_allowed()
+  * @uses get_upload_space_available()
+  *
+  * @param int $size Current max size in bytes
+  * @return int Max size in bytes
+  */
+ function fix_import_form_size( $size ) {
+ 	if ( upload_is_user_over_quota( false ) == true )
+ 		return 0;
+ 
+ 	$available = get_upload_space_available();
+ 	return min( $size, $available );
+ }
+ 
  // Edit blog upload space setting on Edit Blog page
  function upload_space_setting( $id ) {
! 	switch_to_blog( $id );
! 	$quota = get_option( 'blog_upload_space' );
! 	restore_current_blog();
! 
  	if ( !$quota )
  		$quota = '';
  
***************
*** 615,621 ****
  	<?php if ( in_array( get_site_option( 'registration' ), array( 'all', 'blog' ) ) ) : ?>
  		<tr>
  			<th scope="row" colspan="2" class="th-full">
! 				<a href="<?php echo apply_filters( 'wp_signup_location', network_home_url( 'wp-signup.php' ) ); ?>"><?php _e( 'Create a New Site' ); ?></a>
  			</th>
  		</tr>
  	<?php endif; ?>
--- 592,598 ----
  	<?php if ( in_array( get_site_option( 'registration' ), array( 'all', 'blog' ) ) ) : ?>
  		<tr>
  			<th scope="row" colspan="2" class="th-full">
! 				<a href="<?php echo apply_filters( 'wp_signup_location', network_site_url( 'wp-signup.php' ) ); ?>"><?php _e( 'Create a New Site' ); ?></a>
  			</th>
  		</tr>
  	<?php endif; ?>
***************
*** 623,637 ****
  	<?php
  }
  
- function ms_deprecated_blogs_file() {
- 	if ( ! is_super_admin() )
- 		return;
- 	if ( ! file_exists( WP_CONTENT_DIR . '/blogs.php' ) )
- 		return;
- 	echo '<div class="update-nag">' . sprintf( __( 'The <code>%1$s</code> file is deprecated. Please remove it and update your server rewrite rules to use <code>%2$s</code> instead.' ), 'wp-content/blogs.php', 'wp-includes/ms-files.php' ) . '</div>';
- }
- add_action( 'network_admin_notices', 'ms_deprecated_blogs_file' );
- 
  /**
   * Grants super admin privileges.
   *
--- 600,605 ----
***************
*** 650,657 ****
  	// Directly fetch site_admins instead of using get_super_admins()
  	$super_admins = get_site_option( 'site_admins', array( 'admin' ) );
  
! 	$user = new WP_User( $user_id );
! 	if ( ! in_array( $user->user_login, $super_admins ) ) {
  		$super_admins[] = $user->user_login;
  		update_site_option( 'site_admins' , $super_admins );
  		do_action( 'granted_super_admin', $user_id );
--- 618,625 ----
  	// Directly fetch site_admins instead of using get_super_admins()
  	$super_admins = get_site_option( 'site_admins', array( 'admin' ) );
  
! 	$user = get_userdata( $user_id );
! 	if ( $user && ! in_array( $user->user_login, $super_admins ) ) {
  		$super_admins[] = $user->user_login;
  		update_site_option( 'site_admins' , $super_admins );
  		do_action( 'granted_super_admin', $user_id );
***************
*** 678,685 ****
  	// Directly fetch site_admins instead of using get_super_admins()
  	$super_admins = get_site_option( 'site_admins', array( 'admin' ) );
  
! 	$user = new WP_User( $user_id );
! 	if ( $user->user_email != get_site_option( 'admin_email' ) ) {
  		if ( false !== ( $key = array_search( $user->user_login, $super_admins ) ) ) {
  			unset( $super_admins[$key] );
  			update_site_option( 'site_admins', $super_admins );
--- 646,653 ----
  	// Directly fetch site_admins instead of using get_super_admins()
  	$super_admins = get_site_option( 'site_admins', array( 'admin' ) );
  
! 	$user = get_userdata( $user_id );
! 	if ( $user && $user->user_email != get_site_option( 'admin_email' ) ) {
  		if ( false !== ( $key = array_search( $user->user_login, $super_admins ) ) ) {
  			unset( $super_admins[$key] );
  			update_site_option( 'site_admins', $super_admins );
***************
*** 720,726 ****
  <script type="text/javascript">
  //<![CDATA[
  var tb_pathToImage = "../../wp-includes/js/thickbox/loadingAnimation.gif";
- var tb_closeImage = "../../wp-includes/js/thickbox/tb-close.png";
  //]]>
  </script>
  <?php
--- 688,693 ----
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/nav-menu.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/nav-menu.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/nav-menu.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/nav-menu.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 247,257 ****
  		$output .= $indent . '<li>';
  		$output .= '<label class="menu-item-title">';
  		$output .= '<input type="checkbox" class="menu-item-checkbox';
! 		if ( ! empty( $item->_add_to_top ) ) {
  			$output .= ' add-to-top';
  		}
  		$output .= '" name="menu-item[' . $possible_object_id . '][menu-item-object-id]" value="'. esc_attr( $item->object_id ) .'" /> ';
! 		$output .= empty( $item->label ) ? esc_html( $item->title ) : esc_html( $item->label );
  		$output .= '</label>';
  
  		// Menu item hidden fields
--- 247,258 ----
  		$output .= $indent . '<li>';
  		$output .= '<label class="menu-item-title">';
  		$output .= '<input type="checkbox" class="menu-item-checkbox';
! 		if ( property_exists( $item, 'front_or_home' ) && $item->front_or_home ) {
! 			$title = sprintf( _x( 'Home: %s', 'nav menu front page title' ), $item->post_title );
  			$output .= ' add-to-top';
  		}
  		$output .= '" name="menu-item[' . $possible_object_id . '][menu-item-object-id]" value="'. esc_attr( $item->object_id ) .'" /> ';
! 		$output .= isset( $title ) ? esc_html( $title ) : esc_html( $item->title );
  		$output .= '</label>';
  
  		// Menu item hidden fields
***************
*** 511,518 ****
  	}
  	?>
  	<p class="button-controls">
! 		<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
! 		<?php submit_button( __( 'Save' ), 'primary', 'nav-menu-locations', false, disabled( $nav_menu_selected_id, 0, false ) ); ?>
  	</p>
  	<?php
  }
--- 512,519 ----
  	}
  	?>
  	<p class="button-controls">
! 		<?php submit_button( __( 'Save' ), 'primary right', 'nav-menu-locations', false, disabled( $nav_menu_selected_id, 0, false ) ); ?>
! 		<span class="spinner"></span>
  	</p>
  	<?php
  }
***************
*** 560,567 ****
  
  		<p class="button-controls">
  			<span class="add-to-menu">
! 				<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
! 				<input type="submit"<?php disabled( $nav_menu_selected_id, 0 ); ?> class="button-secondary submit-add-to-menu" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-custom-menu-item" id="submit-customlinkdiv" />
  			</span>
  		</p>
  
--- 561,568 ----
  
  		<p class="button-controls">
  			<span class="add-to-menu">
! 				<input type="submit"<?php disabled( $nav_menu_selected_id, 0 ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-custom-menu-item" id="submit-customlinkdiv" />
! 				<span class="spinner"></span>
  			</span>
  		</p>
  
***************
*** 692,702 ****
  			?>
  			<p class="quick-search-wrap">
  				<input type="search" class="quick-search input-with-default-title" title="<?php esc_attr_e('Search'); ?>" value="<?php echo $searched; ?>" name="quick-search-posttype-<?php echo $post_type_name; ?>" />
! 				<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
! 				<?php submit_button( __( 'Search' ), 'quick-search-submit button-secondary hide-if-js', 'submit', false, array( 'id' => 'submit-quick-search-posttype-' . $post_type_name ) ); ?>
  			</p>
  
! 			<ul id="<?php echo $post_type_name; ?>-search-checklist" class="list:<?php echo $post_type_name?> categorychecklist form-no-clear">
  			<?php if ( ! empty( $search_results ) && ! is_wp_error( $search_results ) ) : ?>
  				<?php
  				$args['walker'] = $walker;
--- 693,703 ----
  			?>
  			<p class="quick-search-wrap">
  				<input type="search" class="quick-search input-with-default-title" title="<?php esc_attr_e('Search'); ?>" value="<?php echo $searched; ?>" name="quick-search-posttype-<?php echo $post_type_name; ?>" />
! 				<span class="spinner"></span>
! 				<?php submit_button( __( 'Search' ), 'button-small quick-search-submit button-secondary hide-if-js', 'submit', false, array( 'id' => 'submit-quick-search-posttype-' . $post_type_name ) ); ?>
  			</p>
  
! 			<ul id="<?php echo $post_type_name; ?>-search-checklist" data-wp-lists="list:<?php echo $post_type_name?>" class="categorychecklist form-no-clear">
  			<?php if ( ! empty( $search_results ) && ! is_wp_error( $search_results ) ) : ?>
  				<?php
  				$args['walker'] = $walker;
***************
*** 718,724 ****
  					<?php echo $page_links; ?>
  				</div>
  			<?php endif; ?>
! 			<ul id="<?php echo $post_type_name; ?>checklist" class="list:<?php echo $post_type_name?> categorychecklist form-no-clear">
  				<?php
  				$args['walker'] = $walker;
  
--- 719,725 ----
  					<?php echo $page_links; ?>
  				</div>
  			<?php endif; ?>
! 			<ul id="<?php echo $post_type_name; ?>checklist" data-wp-lists="list:<?php echo $post_type_name?>" class="categorychecklist form-no-clear">
  				<?php
  				$args['walker'] = $walker;
  
***************
*** 727,739 ****
  					$front_page = 'page' == get_option('show_on_front') ? (int) get_option( 'page_on_front' ) : 0;
  					if ( ! empty( $front_page ) ) {
  						$front_page_obj = get_post( $front_page );
! 						$front_page_obj->_add_to_top = true;
! 						$front_page_obj->label = sprintf( _x('Home: %s', 'nav menu front page title'), $front_page_obj->post_title );
  						array_unshift( $posts, $front_page_obj );
  					} else {
  						$_nav_menu_placeholder = ( 0 > $_nav_menu_placeholder ) ? intval($_nav_menu_placeholder) - 1 : -1;
  						array_unshift( $posts, (object) array(
! 							'_add_to_top' => true,
  							'ID' => 0,
  							'object_id' => $_nav_menu_placeholder,
  							'post_content' => '',
--- 728,739 ----
  					$front_page = 'page' == get_option('show_on_front') ? (int) get_option( 'page_on_front' ) : 0;
  					if ( ! empty( $front_page ) ) {
  						$front_page_obj = get_post( $front_page );
! 						$front_page_obj->front_or_home = true;
  						array_unshift( $posts, $front_page_obj );
  					} else {
  						$_nav_menu_placeholder = ( 0 > $_nav_menu_placeholder ) ? intval($_nav_menu_placeholder) - 1 : -1;
  						array_unshift( $posts, (object) array(
! 							'front_or_home' => true,
  							'ID' => 0,
  							'object_id' => $_nav_menu_placeholder,
  							'post_content' => '',
***************
*** 779,786 ****
  			</span>
  
  			<span class="add-to-menu">
! 				<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
! 				<input type="submit"<?php disabled( $nav_menu_selected_id, 0 ); ?> class="button-secondary submit-add-to-menu" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-post-type-menu-item" id="submit-posttype-<?php echo $post_type_name; ?>" />
  			</span>
  		</p>
  
--- 779,786 ----
  			</span>
  
  			<span class="add-to-menu">
! 				<input type="submit"<?php disabled( $nav_menu_selected_id, 0 ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-post-type-menu-item" id="submit-posttype-<?php echo $post_type_name; ?>" />
! 				<span class="spinner"></span>
  			</span>
  		</p>
  
***************
*** 896,902 ****
  					<?php echo $page_links; ?>
  				</div>
  			<?php endif; ?>
! 			<ul id="<?php echo $taxonomy_name; ?>checklist" class="list:<?php echo $taxonomy_name?> categorychecklist form-no-clear">
  				<?php
  				$args['walker'] = $walker;
  				echo walk_nav_menu_tree( array_map('wp_setup_nav_menu_item', $terms), 0, (object) $args );
--- 896,902 ----
  					<?php echo $page_links; ?>
  				</div>
  			<?php endif; ?>
! 			<ul id="<?php echo $taxonomy_name; ?>checklist" data-wp-lists="list:<?php echo $taxonomy_name?>" class="categorychecklist form-no-clear">
  				<?php
  				$args['walker'] = $walker;
  				echo walk_nav_menu_tree( array_map('wp_setup_nav_menu_item', $terms), 0, (object) $args );
***************
*** 923,933 ****
  			?>
  			<p class="quick-search-wrap">
  				<input type="search" class="quick-search input-with-default-title" title="<?php esc_attr_e('Search'); ?>" value="<?php echo $searched; ?>" name="quick-search-taxonomy-<?php echo $taxonomy_name; ?>" />
! 				<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
! 				<?php submit_button( __( 'Search' ), 'quick-search-submit button-secondary hide-if-js', 'submit', false, array( 'id' => 'submit-quick-search-taxonomy-' . $taxonomy_name ) ); ?>
  			</p>
  
! 			<ul id="<?php echo $taxonomy_name; ?>-search-checklist" class="list:<?php echo $taxonomy_name?> categorychecklist form-no-clear">
  			<?php if ( ! empty( $search_results ) && ! is_wp_error( $search_results ) ) : ?>
  				<?php
  				$args['walker'] = $walker;
--- 923,933 ----
  			?>
  			<p class="quick-search-wrap">
  				<input type="search" class="quick-search input-with-default-title" title="<?php esc_attr_e('Search'); ?>" value="<?php echo $searched; ?>" name="quick-search-taxonomy-<?php echo $taxonomy_name; ?>" />
! 				<span class="spinner"></span>
! 				<?php submit_button( __( 'Search' ), 'button-small quick-search-submit button-secondary hide-if-js', 'submit', false, array( 'id' => 'submit-quick-search-taxonomy-' . $taxonomy_name ) ); ?>
  			</p>
  
! 			<ul id="<?php echo $taxonomy_name; ?>-search-checklist" data-wp-lists="list:<?php echo $taxonomy_name?>" class="categorychecklist form-no-clear">
  			<?php if ( ! empty( $search_results ) && ! is_wp_error( $search_results ) ) : ?>
  				<?php
  				$args['walker'] = $walker;
***************
*** 955,962 ****
  			</span>
  
  			<span class="add-to-menu">
! 				<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
! 				<input type="submit"<?php disabled( $nav_menu_selected_id, 0 ); ?> class="button-secondary submit-add-to-menu" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-taxonomy-menu-item" id="submit-taxonomy-<?php echo $taxonomy_name; ?>" />
  			</span>
  		</p>
  
--- 955,962 ----
  			</span>
  
  			<span class="add-to-menu">
! 				<input type="submit"<?php disabled( $nav_menu_selected_id, 0 ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-taxonomy-menu-item" id="submit-taxonomy-<?php echo $taxonomy_name; ?>" />
! 				<span class="spinner"></span>
  			</span>
  		</p>
  
***************
*** 1150,1156 ****
   */
  function _wp_delete_orphaned_draft_menu_items() {
  	global $wpdb;
! 	$delete_timestamp = time() - (60*60*24*EMPTY_TRASH_DAYS);
  
  	// delete orphaned draft menu items
  	$menu_items_to_delete = $wpdb->get_col($wpdb->prepare("SELECT ID FROM $wpdb->posts AS p LEFT JOIN $wpdb->postmeta AS m ON p.ID = m.post_id WHERE post_type = 'nav_menu_item' AND post_status = 'draft' AND meta_key = '_menu_item_orphaned' AND meta_value < '%d'", $delete_timestamp ) );
--- 1150,1156 ----
   */
  function _wp_delete_orphaned_draft_menu_items() {
  	global $wpdb;
! 	$delete_timestamp = time() - ( DAY_IN_SECONDS * EMPTY_TRASH_DAYS );
  
  	// delete orphaned draft menu items
  	$menu_items_to_delete = $wpdb->get_col($wpdb->prepare("SELECT ID FROM $wpdb->posts AS p LEFT JOIN $wpdb->postmeta AS m ON p.ID = m.post_id WHERE post_type = 'nav_menu_item' AND post_status = 'draft' AND meta_key = '_menu_item_orphaned' AND meta_value < '%d'", $delete_timestamp ) );
